# Enhanced Bosses Redone
## An overhaul of Blumaye's Enhanced Bosses
This mod expands the current abilities of existing bosses and adds some new and unique attacks to most of them.

## Configuration
All bosses have their main attack settings configurable in a JSON file. You can enable or disable any attack, control their frequency, or set them to trigger when the boss reaches a certain threshold to add phases to the fight if desired.

Additionally all bosses except The Queen have a special summoning attack that can be configured. She wanted it all, but I gave her nothin'. My bad... You can choose what type and how many monsters get summoned to aid the boss.

Some bosses can recover health or generate shields. These values of health gain, shield absorption and shield time are all adjustable.

Attack frequency can optionally be tuned to increase or decrease throughout the fight, depending on how much health the boss has. Make Bonemass strike you faster, or have The Elder summon Greydwarves and roots more often, or go the other way and make the attacks less frequent as the health changes. The flexibility is yours.

More configuration options have been made available in the .cfg file for certain paramters, see the rest of the readme for details on those. Wait, who READS these days? Biatch, I got audiobooks for that...

## Boss Changes and Attacks (Spoiler Warning)
Enough about the overview and config, let's get into the tweaks! Skip if you wish to be surprised and amazed (well, probably the former, less so of the latter...)

### Eikthyr (Eikthyr)

- Summons Helsvin and Helneck to assist him during the fight. These are stronger than regular Boar and Neck, so be wary!
- Summons smaller clones of himself called Heldyr to aid him in battle when his health gets lower. He is literally making hellspawn of himself.
- Creates an electric vortex that will suck you in before dealing damage. Getting too close might not be a good idea. Or maybe it'll just tingle.
- Brings forth storms to strike you from above (or behind, but who's really watching?)
- Can be configured to teleport when attacking to add more surprise to his patterns. This part is still a bit of a WIP and may be removed.

### The Elder (gd_king)

- Summons Greydwarf and Greydwarf Shaman to help heal him and push you back. As if we needed MORE of those guys...
- Can command trees nearby you to uproot and fall onto you. Don't be cursing the gods when on this spot a tree fell on your head!
- Will absorb trees to restore his maximum HP. Like literally. Eats. Trees. And logs, he likes a few lil' snacks when stomping his enemies.
- Generates a shield when his health gets lower. Dem legz don't grow in a day...
- Teleports if you insist on getting in melee range too much. He is simply dying to show you his vines.

### Bonemass (Bonemass)

- Getting close to Bonemass will cause you to hallucinate, blurring your vision and slowing your movement slightly. Duuuuuude...
- Can additionally summon Draugr, Skeletons and Blobs to aid him during the fight, outside of his usual throw attack. 
- Can summon the power of Ancient Oozers, granting him temporary invulnerability whilst they are alive. And they're pretty, in deep blue!
- Cam slam the ground and cause rock spikes to head towards the player to do damage.
- The poison AOE attack now does more durability damage to your equipped armor. So try not to get caught in the cloud too often... Unless you're into that.

### Moder (Dragon)

- Moder's flight patterns change slightly depending on her health. At high HP she will fly more often, but become grounded more at low HP. Almost like you broke a wing, you monster...
- Drakes will be summoned at points whilst Moder is in the air. Yes. More dragons make more good.
- Wyverns will be summoned at points when Moder is grounded. They have similar attacks to Moder and can also land to deal more damage. Literally like mini-Moders, but NOT the momma!

### Yagluth (GoblinKing)

- Frequencies of the meteor strike and AOE fire fist attack have been adjusted and will increase slightly as the battle progresses. Yag likes two things - Slipknot, and burning you to a crisp.
- Occasionally summons a Fuling Berserker to assist him in the fight. Can they make fire like he can? Nah, they prefer smashy smashy.
- Fire breath can now be shot when you are at a closer range. Cheese him, you say? I think NOT!
- Lightning Quake attack that will deal a large amount of Shock damage on impact. Why? He needed to compensate for having his legs ripped off by Odin.
- Rock Formation attack that will raise Yagluth up on a rock plinth, which you'll need to climb up to reach him.

### The Queen (SeekerQueen)
    
- Increase the frequency of her regular attacks slightly as the fight goes on to make it more difficult to land full combos.
- ... I mean, there's not much extra I REALLY needed to add to her... But ideas are very welcome.

## Compatibility
This mod should be compatible with most other mods, aside from those that adjust any boss AI. Other than that, everything else should work just fine.
This mod seems to work just fine with Creature Level & Loot Control.
This mod should work with Boss Despawn.

## Known Bugs

- Logging out of a game being too close to Bonemass leaves the screen effects active.

## For the Future
I plan to adjust the config more and allow for more fine tuning of certain parameters.
Refactor Bonemass' rock attack a bit to make collision detection more reliable.
More attacks to certain bosses that have a limited roster currently, mainly Moder and Yagluth.
Make The Elder able to launch logs and trees towards players.
Add an Ancient Awakening ability to Moder, swapping her powers from frost to fire for a short duration.

## Contact Me (Bug Reports & Suggestions)
If you have any suggestions, or experience bugs / problems using this mod please get in touch with me on my [Discord](https://discord.gg/K2gnt7ZMHX).

## Changelog

### Changelog 1.9.2

- Reduced health and damage of all of Eikthyr's summons a bit.
- Heldyr, Helneck and Helsvin now have configurable health and damage output.
- Drakes and Wyverns summoned by Moder will now disappear after a configurable amount of time. This will prevent impossible situations where your bow breaks and you're surrounded by creatures that don't land.
- Drakes and Wyverns summoned by Moder now have a configurable amount of health.
- Wyverns summoned by Moder now have configurable blunt and frost damage output from their projectiles.
- Note for updates to 1.9.2 - please delete the mod and it's JSON file and redownload it to get the updated summons.

### Changelog v1.9.1

- Added Harmony patch to remap the boss prefabs on summoning altars to ensure the new attacks are properly called. Should stop the bosses defaulting to normal now. Whoops!

### Changelog v1.9.0

- (Experimental) Yagluth can now cause a rock formation to rise from the ground, raising him up and requiring the player to climb to reach him.
- Fixed issue that could cause a nullref if one of the JSON entries were missing. It will now just render that attack disabled.

### Changelog v1.8.2

- Small code refactor for loading custom attacks and prefabs to make adding additional attacks much easier in future.
- Fixed bug causing ItemDrop prefabs not being instantiated correctly when loaded on Awake().
- Removed bandaid Harmony patch for Humanoid.SetVisEquipment() as prefabs are now no longer null.
- Bonemass will now give a blue cloud when summoning Ancient Oozers.
- Bonemass will now give a yellow cloud when summoning additional creatures.
- Improved rock spawn attack to give rocks of different sizes and rotations.

### Changelog v1.8.1

- Eikthyr Clones attack no longer fires a nullref and will spawn clones properly.

### Changelog v1.8.0

- Initial reupload release.
- Bonemass can now slam the ground to send rocks in the direction of the player. These will deal blunt damage on impact but can be dodged.
- Fixed a nullref that could occur during Assetbundle loading when logging out of a game and logging back in.
- Fixed a loading screen freeze caused from Bonemass rocks and Eikthyr clouds.
- Fixed Ancient Oozers sometimes flying away from Bonemass instead of moving towards him and circling.
- Boss spawns from summon attacks no longer drop items in order to prevent entity buildup and lag in case of many summons.

### Changelog v1.7.2

- Added configuration options for amount of Eikthyr spawn clouds summoned.
- Added configuration options for amount of Ancient Oozers that can spawn.
- Config values will now clamp to the suggested min/max values if set outside these ranges.
- All bosses now read from HP cooldown threshold config correctly even if one is specified already in original attacks.

### Changelog v1.7.1

- Eikthyr can now summon storm clouds to float nearby and deal damage at random to targets below.
- Adjusted particlesystem of the clouds to follow local position instead of world position. They now correctly follow the intended flight paths.
- Fixed a nullref that could occasionally happen if Eikthyr was killed before storm clouds had disappeared. 
- Fixed a nullref that could occasionally happen if Bonemass was killed before Ancient Oozers had disappeared.
- Fixed endless coroutine loading on storm clouds. Should properly clean up when storm clouds are not needed.
- Reduced calculation cost on Ancient Oozer movement.
- Removed soft dependency for MonsterLabZ being required for the storm attack to become available.

### Changelog v1.7.0

- Updated to work with Valheim 0.214.2 build.
- Removed dependency of JotunnLib and completely reworked all code to handle better loading of boss attacks.
- Removed unnecessary methods in much of the core library and helper classes.
- All parts of the mod are now properly namespaced and organised.
- Adjusted Ancient Oozer movement logic and now the movement is controlled via an attached script instead of a convoluted coroutine.
- Added Storm Cloud prefab (eb_thundercloud) from kitbashed vanilla files, to be used by Eikthyr later.

### Changelog v1.6.1

- Adjusted Elder teleport logic and effect. He will now teleport away occasionally when in melee range to give him a chance to use some more ranged attacks.
- Adjusted Elder tree healing. He will now summon logs to him and heal up if they are absorbed.
- Heal for Elder changed to be a per-second tick.
- Fixed nullref caused by Eikthyr clones.
- Added better VFX to Eikthyr's electric vortex.
- Improved summon spawn logic for bosses to stop summons going into the ground.

### Changelog v1.6.0

- Yagluth now has a new attack that can spew lightning from the ground around the player.
- Bonemass now has a new attack that will summon Ancient Slimes. They will float above Bonemass and make him impervious to damage until they are destroyed, and after some time will terminate themselves heal Bonemass.
- Bonemass turns blue whilst in an impervioius state.
- Refactored summon attack code to allow for easier addition of custom summon fx. Will be available in config in the future.
- Boss attack frequency will now change according to how much health they have left. Configurable in the JSON file.

### Changelog v1.5.0
    
- Reuploaded new version Enhanced Bosses Redone. 
- Fixed a bug that would prevent the last creature from summon lists being selected. All entries should now have an equal probability of getting selected.
- All attacks should now use the HP threshold correctly and enable / disable correctly when read from configs, as only a few of these were working before.
- Reworked Eikthyr's clone ability so that it will summon smaller Heldyr to assist him in the fight instead.
- Eikthyr's clone ability will no longer instakill players when triggered during a player's attack animation.
- Config option to enable or disable Eikthyr teleporting during attacks has been added. Defaults to false.
- Config option to increase or decrease the number of Heldyr he summons.
- The Elder's root spawn attack now works properly again.
- Added config option to adjust Bonemass' AOE attack doing damage to armor's remaining durability. Significantly reduced from 50% to 3%.
- Added config option to adjust Bonemass' hallucination intensity, so you can still enable it with less intensity if desired. Reduced default intensity of screen shear.
- Added config option to adjust Bonemass' hallucination slowdown effect, and reduced the default speed penalty from 60% to 20%.
- Added config options for Moder's takeoff and landing behaviour when passing the HP threshold, meaning she will not always be in the air before reaching that threshold. By default she will still land infrequently before her HP hits 75%.
- Removed probability that creatures summoned would have stars in order to make it compatible with Creature Level & Loot Control.

### Changelog v1.4.3

- Fixed on load bug.

### Changelog v1.4.2

- Updated to work with Valheim 0.212.7 build.
- Removed RRRCore and RRRMonsters dependencies.
- Removed Eikthyr clones ability.

### Changelog v1.4.0

- Improved performance.
- Added new attack to Eikthyr - Electric Vortex.
- Added the ability to disable attacks or change cooldowns via JSON.

### Changelog v1.3.0

- The Elder hsa improved teleport logic.
- Bonemass hallucinations now act as an aura.
- Bosses are now displayed on the map.
- Added compatibility with ValheimFPSBoost.

### Changelog v1.2.0

- Eikthyr can now summon clones. Improved some of his other attacks.
- The Elder can now teleport to the player. 
- The Elder's tree eating ability has been improved. 
- The Elder can now cast a shield to protect himself.
- Bonemass AOE attack may cause hallucinations, be careful! (inspired by shrooms)
- Added detailed setting for each boss.
- Added dependencies for RRRCore and RRRMonsters.

## Installation
Move the 'plugins' and 'config' folders from the archive to your BepInEx folder.
If you are updating and get the note of missing JSON configuration, delete the mod and redownload to get the most recent one.

## Credits
### Blumaye
The original author of this mod.
### MrModdieMax
Initial reuploader of this mod and updating the mod to also include The Queen for the Mistlands update.

## Disclaimer
I will continue working on this mod unless requested by Blumaye to remove it from Thunderstore, in which case I will do so, but probably be very sad.
As Blumaye is the original author, I grant them permission to upload my maintained version in their name and account if desired. Keep it ALIVE!
If my right to work on this version of the mod is withdrawn, Blumaye is also welcome to rename this maintained version back to its original, Enhanced Bosses.
If you wish to donate to support development, please message Blumaye directly - this was their mod so I won't be taking donations for this.